VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form frmStunnelShell 
   Caption         =   "Enter the HTTPS URL you would like to Raw Request"
   ClientHeight    =   3915
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7995
   LinkTopic       =   "Form1"
   ScaleHeight     =   3915
   ScaleWidth      =   7995
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkSaveCmdLine 
      Caption         =   "Save cmdLine"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4320
      TabIndex        =   6
      Top             =   3000
      Width           =   1695
   End
   Begin VB.TextBox txtCert 
      BackColor       =   &H8000000B&
      Height          =   375
      Left            =   2760
      Locked          =   -1  'True
      OLEDropMode     =   1  'Manual
      TabIndex        =   5
      ToolTipText     =   "Drag and drop the pem file here (location will be saved)"
      Top             =   3480
      Width           =   5175
   End
   Begin VB.CheckBox chkClientCert 
      Caption         =   "Use Specific Client Cert"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   0
      TabIndex        =   4
      Top             =   3480
      Width           =   3495
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "?"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   6120
      TabIndex        =   3
      Top             =   3000
      Width           =   495
   End
   Begin MSWinsockLib.Winsock ws 
      Left            =   3840
      Top             =   3000
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.CommandButton cmdDone 
      Caption         =   "Done"
      Height          =   375
      Left            =   6720
      TabIndex        =   1
      Top             =   3000
      Width           =   1215
   End
   Begin VB.TextBox txtUrl 
      Height          =   2895
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   0
      Width           =   7935
   End
   Begin VB.Label lblFreeport 
      Caption         =   "Stunnel will listen on port :"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   11.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   0
      TabIndex        =   2
      Top             =   3000
      Width           =   3855
   End
End
Attribute VB_Name = "frmStunnelShell"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Dim freeport As Long
Dim lastErr As String
Dim stunnel As String


Private Sub Form_Load()
    Dim i As Integer
    
    #If standalone = 0 Then
        LoadUrlFrom_frmMain
    #End If
    
    stunnel = App.path & "\stunnel.exe"
    txtCert = GetSetting("stunnel_plugin", "Config", "PEMFILE", "")
    chkClientCert.Value = GetSetting("stunnel_plugin", "Config", "UsePEMFILE", 0)
    
    If Not FileExists(stunnel) Then
        UghhOghhh "Could not locate stunnel looking for it: " & vbCrLf & vbCrLf & stunnel
    End If
    
    For i = 0 To 200
        If IsFreePort(i + 1030) Then
            freeport = i + 1030
            lblFreeport = lblFreeport & freeport
            Exit Sub
        End If
    Next
    
    UghhOghhh "Could not locate free port in range 1030-1230 for stunnel to listen on, exiting"
   
    
End Sub
  
Private Sub cmdDone_Click()
    Dim url, host, port, fslash, colon
    Dim rawreq As Object  'class instance of RawRequest.clsRawRequest for 1.4 users
    
    If chkClientCert.Value = 1 And Not FileExists(txtCert) Then
        MsgBox "Client Cert not found please drag and drop the cert you want to use into the textbox below", vbExclamation
        Exit Sub
    End If
    
    url = Replace(Trim(txtUrl), vbCrLf, Empty)
    url = Replace(url, "https://", Empty, , , vbTextCompare)
    url = Replace(url, "http://", Empty, , , vbTextCompare)
    url = Replace(url, "\", "/")
    
    If Len(url) = 0 Then
        MsgBox "Please entrer a url or close the window", vbExclamation
        Exit Sub
    End If
    
    fslash = InStr(url, "/")
    If fslash < 1 Then
        host = url
    Else
        host = Mid(url, 1, fslash - 1)
    End If
    
    url = Replace(url, host, Empty)
    If Len(url) = 0 Then url = "/"
    
    colon = InStr(host, ":")
    If colon < 1 Then
        port = 443
    Else
        port = Split(host, ":")(1)
        host = Replace(host, ":" & port, Empty)
    End If
    
    If Not IsNumeric(port) Then
        MsgBox "invalid port: " & port, vbExclamation
        Exit Sub
    End If
    
    If Not startStunnel(CStr(host), CLng(port)) Then
        MsgBox "Stunnel startup failed:" & vbCrLf & vbCrLf & lastErr, vbExclamation
        Exit Sub
    End If
    
    url = "http://127.0.0.1:" & freeport & url
    
    #If standalone = 0 Then
        If isSleuth14 Then
            On Error GoTo hell
            Set rawreq = CreateObject("RawRequest.clsRawRequest")
            rawreq.PrepareRawRequest url
        Else
            'the new rawrequest is a licensed component, 1.36 users would just get a
            'demo expired error if it was started up so we copy the url to the clipboard
            'for them and let them use the old built in rawreq of sleuth 1.3x
            Clipboard.Clear
            Clipboard.SetText url
            MsgBox "Configured Url saved to clipboard" & vbCrLf & vbCrLf & _
                   "Now goto Plugins -> RawRequest and paste in this configured URL" & vbCrLf & vbCrLf & _
                   "Note: You are probably going to have to manually transfer the " & vbCrLf & _
                   "      port number over to the port textbox because it looks " & vbCrLf & _
                   "      old 1.36 raw request does not seem to bother to parse it" & vbCrLf & _
                   "      over for you..I have just updated the old 1.36 to add this" & vbCrLf & _
                   "      functionality. See the updates page on the website to download" & vbCrLf & _
                   "      the updated exe. ", vbInformation, "Sleuth 1.36"
        End If
    #Else
        Clipboard.Clear
        Clipboard.SetText url
        MsgBox "Configured Url saved to clipboard", vbInformation, "SConfig.exe"
    #End If
    
    Unload Me
    
 Exit Sub
hell: MsgBox Err.Description
      
End Sub


Function startStunnel(connectToHost As String, connectToPort As Long) As Boolean
    On Error GoTo hell
    Dim cmd As String
    'stunnel -c -d pop3 -r bar:pop3s
    
    cmd = " -c -d <listenPort> -r <connectHost>:<connectPort>"
    cmd = Replace(cmd, "<listenPort>", freeport)
    cmd = Replace(cmd, "<connectHost>", connectToHost)
    cmd = Replace(cmd, "<connectPort>", connectToPort)
    
    If chkClientCert.Value = 1 Then
        cmd = cmd & " -p """ & txtCert & """"
    End If
       
    If chkSaveCmdLine.Value = 1 Then
        WriteFile App.path & "\stunnel.bat", stunnel & cmd
    End If
    
    Debug.Print stunnel & cmd
    
    Shell stunnel & cmd, vbNormalFocus
    startStunnel = True
    
    Exit Function
hell: lastErr = Err.Description

End Function


Private Sub cmdHelp_Click()
    Dim tmp As String
    On Error Resume Next
    tmp = App.path & "\SSL_RawReq_Readme.txt"
    If Not FileExists(tmp) Then
        MsgBox "Could not find " & tmp, vbExclamation
        Exit Sub
    Else
        Shell "notepad """ & tmp & """", vbNormalFocus
    End If
End Sub




Function IsFreePort(X As Long) As Boolean
    On Error GoTo hell
    
    wsClose
    ws.LocalPort = X
    ws.Bind
    wsClose
    IsFreePort = True
    
    Exit Function
hell:
End Function

Sub wsClose()
    On Error Resume Next
    ws.Close
End Sub



Function FileExists(path) As Boolean
  If Len(path) = 0 Then Exit Function
  If Dir(path, vbHidden Or vbNormal Or vbReadOnly Or vbSystem) <> "" Then FileExists = True
End Function
 
Sub WriteFile(path, it)
    On Error Resume Next
    Dim f As Long
    f = FreeFile
    Open path For Output As #f
    Print #f, it
    Close f
End Sub

Private Sub Form_Unload(Cancel As Integer)
    SaveSetting "stunnel_plugin", "Config", "UsePEMFILE", chkClientCert.Value
End Sub

Private Sub txtCert_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim f As String
    f = Data.Files(1)
    
    If Not FileExists(f) Or LCase(Right(f, 4)) <> ".pem" Then
        MsgBox "Only drop .pem files in here to use as client certs", vbExclamation
        Exit Sub
    End If
        
    SaveSetting "stunnel_plugin", "Config", "PEMFILE", f
        
    txtCert = f
        
End Sub

Sub LoadUrlFrom_frmMain()
    On Error Resume Next
    txtUrl = Replace(frmMain.txtUrl, "&", vbCrLf & "&")
    txtUrl = Replace(txtUrl, "?", vbCrLf & vbCrLf & "?")
End Sub

Sub UghhOghhh(msg)
    txtUrl.Enabled = False
    cmdDone.Enabled = False
    txtUrl = txtUrl & vbCrLf & vbCrLf & msg
End Sub
